BG_ControlCommon = {}
local P = {}

P.specializations={-- All "spec only" spells that do direct damage/healing
            ["DEATHKNIGHT"]={
                -- Soul Reaper (Blood)
                ["114866"]=250,
                -- Frost Strike (Frost), Howling Blast (Frost), Obliterate (Frost), Soul Reaper (Frost)
                ["49143"]=251,["49184"]=251,["49020"]=251,["130735"]=251,
                -- Scourge Strike (Undead), Festering Strike (Undead)
                ["55090"]=252,["85948"]=252
            },

            ["DRUID"]={
                -- Starfire (Balance), Starsurge (Balance), Solar Beam (Balance), Starfall (Balance)
                ["2912"]=102,["78674"]=102,["78675"]=102,["48505"]=102,
                -- Rake (Feral), Swipe (Feral), Maim (Feral)
                ["1822"]=103,["106785"]=103,["22570"]=103,
                -- Maul (Guardian), Lacerate (Guardian)
                ["6807"]=104,["33745"]=104,
                -- Swiftmend (Resto), Regrowth (Rest), Lifebloom (Rest)
                ["18562"]=105 ,["8936"]=105 ,["33763"]=105
            },
            ["HUNTER"]={
                -- NO PLAYER -> INSTANT DAMAGE SPELLS FOR BM?!
                -- Aimed Shot (Marks), Chimara Shot (Marks)
                ["19434"]=254,["53209"]=254,
                -- Explosive Shot (Surv)
                ["53301"]=255
            },
            ["MAGE"]={
                -- Arcane Blast (Arcane), Arcane Barrage (Arcane), Arcane Explosion (Arcane), Arcane Missles (Arcane)
                ["30451"]=62,["44425"]=62,["1449"]=62,["5143"]=62,
                -- Dragon's Breath (Fire), Inferno Blast (Fire), Pyroblast (Fire), Fireball (Fire), Scorch (Fire)
                ["31661"]=63,["108853"]=63,["11366"]=63,["133"]=63,["2948"]=63,
                -- Frostbolt (Frost), Ice Lance (Frost)
                ["116"]=64,["30455"]=64,
            },
            -- Revival, Detonate, Uplift
            ["MONK"]={
                -- Keg Smash (Brewmaster), Breath of Fire (Brewmaster)
                ["121253"]=268,["115181"]=268,
                -- Revival (Mistweaver), Detonate Chi (Mistweaver), Uplift (Mistweaver)
                ["115310"]=270,["115460"]=270,["116670"]=270,
                -- Flying Serpent Kick (Windwalker)
                ["10154"]=269,

            },
            ["PALADIN"]={
                -- Holy Shock, Holy Radiance, Holy Light, Light of Dawn
                ["20473"]=65,["82327"]=65,["82326"]=65,["85222"]=65,
                -- Avenger's Shield (Prot), Holy Wrath (Prot), Shield of the Righteous (Prot)
                ["31935"]=66,["119072"]=66,["53600"]=66,
                -- Templar's Verdict (ret), Divine Storm (ret), Exorcism (Ret)
                ["85256"]=70,["53385"]=70,["879"]=70,

            },
            -- Penance, Holy Nova | Binding HEal, Circle of Healing, Divine Hymn
            ["PRIEST"]={
                -- Penance (Disc), Holy Nova (Disc)
                ["47540"]=256,["132157"]=256,
                -- Binding Heal (holy), Circle of Healing (holy), Divine Hymn (Holy)
                ["32546"]=257,["34861"]=257,["64843"]=257,
                -- Devouring Plague (Shadow), Mind Blast (Shadow), Mind Spike (Shadow), Shadow Word: Death (Shadow)
                ["2944"]=258,["8092"]=258,["73510"]=258,["32379"]=258,
            },
            ["ROGUE"]={
                -- Mutilate (Ass), Envenom (Ass), Dispach (Ass)
                ["1329"]=259,["32645"]=259,["111240"]=259,
                -- Revealing Strike (Combat), Killing Spree (Combat)
                ["84617"]=260,["51690"]=260,
                --  Hemorrhage (Sub), Backstab (Sub)
                ["16511"]=261,["53"]=261,
            },
            -- Riptide, Chain Heal, Healing Wave
            ["SHAMAN"]={
                ["61295"]=264,["1064"]=264,["77472"]=264,
            },
            ["WARLOCK"]={
            },
            ["WARRIOR"]={
            }
        }


--      .specializations { "class"={"spellid"=spec } }

function BG_ControlCommon.Print(str)
    -- This contains a curseforge macro to not package when deployed.
    --  See repository
    
end

function BG_ControlCommon.SpecializationBySpell(spellID,class)
    if not class then
        for i=1,GetNumClasses() do
            local _,c = GetClassInfo(i);
            local c1 = BG_ControlCommon.SpecializationBySpell(spellID,c);
            if c1 then
                return c1,class;
            end
        end
        return nil;
    end
    return P.specializations[class][tostring(spellID)], class;
end

function BG_ControlCommon.Distance(from,to,yardsScaler)
    if not from["x"] or not from["y"] or not to["x"] or not to["y"] then
        print("DISTANCE FAIL")
        return nil
    end
    if not yardsScaler then yardsScaler = 1 end
    local x = from["x"] - to["x"]
    local y = from["y"] - to["y"]
    return ( (x * x + y * y) ^ 0.5 ) * yardsScaler
end

function BG_ControlCommon.IsHostile(flags)
    return bit.band(flags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0
end

function BG_ControlCommon.IsPlayer(flags)
    return bit.band(flags,COMBATLOG_OBJECT_TYPE_PLAYER) > 0
end

function BG_ControlCommon.IsFriendly(flags)
    return bit.band(flags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0
end

function BG_ControlCommon.BgID()
    local _, _, _, _, _, _, _, bgID = GetInstanceInfo()
    return bgID
end

function BG_ControlCommon.IsHealer(specID)
    if not specID then return nil; end

    local _, _, _, _, _, role = GetSpecializationInfoByID(specID);
    return "HEALER" == role
end

function P.InitSpecializations()

end